# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 20010 Akretion LDTA (<http://www.akretion.com>).
#    @author Raphaël Valyi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from tools.translate import _
from osv import fields, osv


class purchase_order(osv.osv):
    _inherit = "purchase.order"

    _columns = {
        'phase_id': fields.many2one('project.phase', 'Project Phase'),
        'related_project_id':fields.related('phase_id', 'project_id', type='many2one', relation='project.project', string='Project', store=True),
    }

    def action_picking_create(self,cr, uid, ids, *args):
        res = super(purchase_order, self).action_picking_create(cr, uid, ids, *args)
        for purchase in self.browse(cr, uid, ids):
            if res: #TODO bad code inherited from OpenERP, see bug https://bugs.launchpad.net/openobject-addons/+bug/788789
                if purchase.sale_flow in ['direct_delivery', 'direct_invoice_and_delivery']:
                    self.pool.get('stock.picking').write(cr, uid, res, {'phase_id': purchase.phase_id and purchase.phase_id.id, 'sale_id': purchase.sale_id and purchase.sale_id.id})
        return res

purchase_order()
