# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 20010 Akretion LDTA (<http://www.akretion.com>).
#    @author Raphaël Valyi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from tools.translate import _
from osv import fields, osv

class sale_order_line(osv.osv):
    _inherit = "sale.order.line"
    
    _columns = {
        'phase_id': fields.many2one('project.phase', 'Phase'),
        'resource_product_id': fields.many2one('project.product.allocation', 'Product Allocation'),
     }
sale_order_line()


class sale_order(osv.osv):
    _inherit = "sale.order"
    
    def action_ship_create(self, cr, uid, ids, *args):
        order_without_project = []
        for order in self.browse(cr, uid, ids):
            if order.true_project_id:
                self.pool.get('project.project').action_create_pickings(cr, uid, [order.true_project_id.id], *args)
            else:
                order_without_project.append(order.id)
        return super(sale_order, self).action_ship_create(cr, uid, order_without_project, *args)

    def get_order_lines_to_invoice(self, cr, uid, ids, context=None):
        lines = super(sale_order, self).get_order_lines_to_invoice(cr, uid, ids, context)
        for order in self.browse(cr, uid, ids):
            for line in order.order_line:
                if line.resource_product_id:
                    phase = line.resource_product_id.phase_id
                    if phase.state not in ('draft', 'cancel'):
                        total_invoiceable_amount = 0
                        for picking in phase.picking_ids:
                            if picking.state == 'done':
                                for move in picking.move_lines:
                                    if move.sale_line_id.id == line.id:
                                        invoice_qty = 0
                                        for inv_line in line.invoice_lines:
                                            invoice_qty += inv_line.quantity
                                        sent_quantity = 0
                                        for move in line.move_ids:
                                            if move.state == 'done':
                                                sent_quantity += move.product_uos_qty
                                        
                                        delta_quantity = sent_quantity - invoice_qty
                                        if abs(delta_quantity) > 0.01:
                                            if line.resource_product_id.product_corrected_qty: #real required quantity might be different from estimated quantity:
                                                if sent_quantity <= line.resource_product_id.product_corrected_qty:
                                                    invoiceable_amount = delta_quantity * line.price_unit - total_invoiceable_amount - total_invoiceable_amount
                                                else:
                                                    invoiceable_amount = (line.resource_product_id.product_corrected_qty - invoice_qty) * line.price_unit - total_invoiceable_amount
                                                #invoiceable_amount =  line.resource_product_id.product_estimated_qty / line.resource_product_id.product_corrected_qty * delta_quantity * line.price_unit
                                            else:
                                                invoiceable_amount = delta_quantity * line.price_unit
                                            total_invoiceable_amount += invoiceable_amount
                                            if abs(invoiceable_amount) > 0.01:
#TODO                                                if line.is_provided_by_customer:
#                                                     invoiceable_amount = 0
                                                lines.append([line, invoiceable_amount, move.product_id.id])
        return lines
    
sale_order()
